-------------------------------------------------------------------------------
-- cometTrackview.ms 
--	Michael Comet - http://www.comet-cartoons.com/ - comet@comet-cartoons.com
--
--	
--
-- Most of the code it totally ripped off of/based on the
--		"TrackViewReady.ms" By Neil Blevins (soulburn@blur.com)
--
-------------------------------------------------------------------------------
--
-- Description:
-- Similar to Trackview selected, except also only shows animated tracks and 
-- it's already unrolled.
--
--
-- Version 1.01 - Michael B. Comet - Added new fcurve stuff based off of Neil's
--				original script
-- Version 1.02 - Michael B. Comet - Added Bezier_Color type as supported type.
--
-------------------------------------------------------------------------------

(

-- Close it if it already exists
for t in 1 to Trackview.NumTrackViews() do
	(
	If Trackview.GetTrackviewName T == "cometTrackview" then 
		(
		trackviews.close "TrackviewReady"
		)
	else 
		(
		)
	)
-- Make a new one
TrackView.Open "cometTrackview"
TrackView.setFilter "cometTrackview" #modifiedObjects #SelectedObjects #animatedTracks #curveX #curveY #curveZ #Objects #Hierarchy #Transforms #Position #Rotation #Scale #positionX #positionY #positionZ #rotationX #rotationY #rotationZ #scaleX #scaleY #scaleZ
TrackView.zoomSelected "cometTrackview"

/* --  don't need to do this any more since now fcurve mode
if selection.count != 0 then 
	TrackView.zoomSelected Selection[1].name
*/
trackviews.currentTrackView.expandTracks()


-- Now put it into fcurve mode
tvInterface = trackviews.getTrackView "cometTrackview";
tvInterface.setEditMode #editFCurves;

	-- And select ALL the tracks of the type that we would want to see or select...
if selection.count != 0 then  (
	numT = tvInterface.getNumTracks()
	didSelect = false;		-- have we done anything yet?
	for t in 1 to numT do (
		myTrack = tvInterface.getTrack t;
		theClass = classOf myTrack;
		if (theClass == Linear_Position or 	theClass == Noise_Position or 	
			theClass == Position_Reactor or theClass == TCB_Position or 	
			theClass == Bezier_Position or theClass == Bezier_Color or 
	
			theClass == Linear_Rotation or	theClass == Noise_Rotation or 	
			theClass == Rotation_Reactor or	theClass == TCB_Rotation or 
			
			theClass == Bezier_Scale or		theClass == Linear_Scale or
			theClass == Noise_Scale or 		theClass == Scale_Reactor or
			theClass == TCB_Scale or
			
			theClass == Bezier_Float or 	theClass == Float_Reactor or
			theClass == Linear_Float or 	theClass == Noise_Float or
			theClass == On_Off or 			theClass == TCB_Float or
			theClass == Waveform_Float	) then (
	
				tvInterface.selectTrackByIndex t (not didSelect);
				didSelect = true;
				)
				
		)
	)
)

