-- scatter-to-verts.ms - Michael B. Comet -  comet@comet-cartoons.com
--     	http://www.comet-cartoons.com/
--
--  Clone the selected object to each of the dst object vertices
--
--

global src=undefined
global dst=undefined


fn is_mesh obj = (
	try (
		i = obj.numverts
		return true
		)
	catch (
		)
	return false;
)

fn filter_src obj = (
	if obj != dst then
		return true;
	return false;
)

fn filter_dst obj = (
    if (is_mesh obj) == true then (
		if obj != src then
			return true;
		)
	return false;
)

fn scat = (
	if (is_mesh dst) != true then (
		messageBox "Destination Object is not a mesh" title:"Ooops!" beep:true
		return 0;
	)

    n = dst.numverts
    for i = 1 to n do (
	c = copy src;
	c.pos = dst.verts[i].pos
	)
)

rollout rolloutAction "Action"
(
	pickbutton btn_src "PICK Source" tooltip:" Object to clone" width:150 align:#center filter:filter_src
	pickbutton btn_dst "PICK Destination" tooltip:"Surface vertices" width:150 align:#center filter:filter_dst
	label b1 "Scatter:" align:#left
	button btn_doit "Scatter To Verts" tooltip:"Creates copies of Source onto Dest" width:150 align:#center enabled:false

	on btn_src picked obj do (
		src = obj;
		btn_src.text = src.name;
		if dst != undefined then (
			btn_doit.enabled = true;
			)
	)

	on btn_dst picked obj do (
		dst = obj;
		btn_dst.text = dst.name;
		if src != undefined then (
			btn_doit.enabled = true;
			)
	)

	on btn_doit pressed do (
		undo on (
			scat();	
			)
	)
)

rollout rolloutAbout "About"
(
	label abt_1 "Scatter To Verts v1.0" align:#center
	label abt_2 "By" align:#center
	label abt_3 "Michael B. Comet" align:#center
	label abt_4 "comet@comet-cartoons.com" align:#center
	label abt_5 "http://www.comet-cartoons.com/" align:#center
)


rolloutSFloater = newRolloutFloater "Scatter To Verts" 200 190
addRollout rolloutAction rolloutSFloater
addRollout rolloutAbout rolloutSFloater rolledUp:true

